import java.util.Random;

class TestExo1 {

    static final int nbPlaces = 3;
    static final int nbThreads = 10;
    static final int nbIterations = 100;

    static void testParking(Parking parking) {
        long occupant[] = new long[nbPlaces];
        final Random rand = new Random();
        for(int i=0;i<nbThreads;i++){
            new Thread( () -> {
                long id = Thread.currentThread().getId();
                for(int j=0;j<nbIterations;j++){
                    int place = 0;
                    while(place == 0) place=parking.get_free_place();
                    occupant[place-1] = id;
                    try { Thread.sleep((long) (rand.nextFloat() * 10)); }
                    catch (InterruptedException e) {System.out.println("exception levée");}
                    if (occupant[place-1] != id) System.out.println("pas d'exclusion k-mutuelle!");
                    parking.leave_place();
                }
            }).start();
        }
    }

    public static void main(String []args){
        testParking(new ParkingBloquant(nbPlaces));
        testParking(new ParkingNonBloquant(nbPlaces));
    }

}