import java.util.Random;

class Exo2 {

    static Random rand;

    static double prodScalSequentiel(double []a, double []b, int n){
        double res = 0;
        for(int i=0; i<n; i++) res += a[i] * b[i];
        return res;
    }

    static double prodScal(double []a, double []b, int n, int nbThreads) {
        /* à modifier et compléter */
        return prodScalSequentiel(a, b, n);
    }


    static double [] randVec(int n){
        double [] res = new double[n];
        for(int i=0; i<n; i++) res[i] = rand.nextDouble();
        return res;
    }

    static void runTest(int n, int nbThreads){
        double []a = randVec(n);
        double []b = randVec(n);
        final double []res = new double[2];
        float tSeq = Chrono.run( () -> { res[0] = prodScalSequentiel(a, b, n);} );
        float tPar = Chrono.run( () -> { res[1] = prodScal(a, b, n, nbThreads);} );
        float speedup = tSeq / tPar;
        boolean status = (Math.abs(res[0] - res[1]) < 0.01);
        System.out.printf("n=%d, nbThreads=%d, speedup=%f, correct=%b\n", n, nbThreads, speedup, status);
    }

    public static void main(String []args){
        rand = new Random();
        runTest(1000000, 2);
        runTest(1000000, 3);
        runTest(10000000, 2);
        runTest(10000000, 3);
        runTest(10000000, 4);
    }

}    

